---
policy: /ce/ca/aws/rds/instance-cloudwatch-logs-export
logic: /ce/ca/aws/rds/instance-cloudwatch-logs-export/prod.logic.yaml
executionTime: 2026-01-31T12:02:12.2075397Z
generationMs: 57
executionMs: 976
rows:
  - id: '001'
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: '002'
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 399
      actual: 399
    conditionText:
      expected: extract('CA10__enabledCloudWatchLogsExports__c').isNotEmpty()
      actual: extract('CA10__enabledCloudWatchLogsExports__c').isNotEmpty()
    runtimeError: {}
  - id: '003'
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 400
      actual: 400
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/rds/instance-cloudwatch-logs-export/policy.yaml
    md5Hash: DFEC3B4A5B6E513CE98870F4BA8C664A
    content: "---\nnames:\n  full: \"AWS RDS Instance database logging is not enabled\"\
      \n  contextual: \"Instance database logging is not enabled\"\ndescription: >\n\
      \  Amazon RDS can export various database engine logs to CloudWatch Logs. Enabling\
      \ \n  these exports provides persistent storage for logs and allows you to use\
      \ CloudWatch \n  Alarms to monitor database activity and troubleshoot performance\
      \ issues.\ntype: \"COMPLIANCE_POLICY\"\ncategories:\n  - \"RELIABILITY\"\nframeworkMappings:\n\
      \  - \"/frameworks/cloudaware/logging-and-monitoring/logging-and-monitoring-configuration\"\
      \n  - \"/frameworks/aws-fsbp-v1.0.0/rds/09\"\n  - \"/frameworks/aws-fsbp-v1.0.0/rds/36\"\
      \n  - \"/frameworks/aws-fsbp-v1.0.0/rds/40\"\nsimilarPolicies:\n  awsSecurityHub:\n\
      \    - name: \"[RDS.9] RDS DB instances should publish logs to CloudWatch Logs\"\
      \n      url: \"https://docs.aws.amazon.com/securityhub/latest/userguide/rds-controls.html#rds-9\"\
      \n    - name: \"[RDS.36] RDS for PostgreSQL DB instances should publish logs\
      \ to CloudWatch Logs\"\n      url: \"https://docs.aws.amazon.com/securityhub/latest/userguide/rds-controls.html#rds-36\"\
      \n    - name: \"[RDS.40] RDS for SQL Server DB instances should publish logs\
      \ to CloudWatch Logs\"\n      url: \"https://docs.aws.amazon.com/securityhub/latest/userguide/rds-controls.html#rds-40\"\
      \n"
  - path: /ce/ca/aws/rds/instance-cloudwatch-logs-export/prod.logic.yaml
    md5Hash: 7545B5C826FBE10ED8604CC8FA7D45D6
    content: |-
      ---
      inputType: "CA10__CaAwsDbInstance__c"
      testData:
        - file: test-data.json
      importExtracts:
        - file: /types/CA10__CaAwsDbInstance__c/object.extracts.yaml
      conditions:
        - status: "INAPPLICABLE"
          currentStateMessage: "The Instance is not available."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10__status__c"
              right:
                TEXT: "available"
        - status: "INAPPLICABLE"
          currentStateMessage: "This policy doesn't apply to Cluster Instances."
          check:
            NOT_EMPTY:
              arg:
                EXTRACT: "CA10__clusterArn__c"
        - status: "COMPLIANT"
          currentStateMessage: "The RDS Instance is configured to publish logs to CloudWatch."
          check:
            NOT_EMPTY:
              arg:
                EXTRACT: "CA10__enabledCloudWatchLogsExports__c"
      otherwise:
        status: "INCOMPLIANT"
        currentStateMessage: "The RDS Instance is not configured to publish logs to CloudWatch."
        remediationMessage: "Modify the RDS instance to enable CloudWatch logs."
  - path: /ce/ca/aws/rds/instance-cloudwatch-logs-export/test-data.json
    md5Hash: B880CDF33965C84FB5B86F513B17AF12
    content: |
      [
        {
          "expectedResult": {
            "status": "DISAPPEARED",
            "conditionIndex": "99",
            "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-12-17T04:44:14Z" },
          "CA10__disappearanceTime__c": "2025-12-12T10:23:44Z",
          "CA10__enabledCloudWatchLogsExports__c": "",
          "CA10__clusterArn__c": "",
          "CA10__status__c": "available",
          "Id": "001"
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "399",
            "conditionText": "extract('CA10__enabledCloudWatchLogsExports__c').isNotEmpty()",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-12-17T04:44:14Z" },
          "CA10__disappearanceTime__c": null,
          "CA10__enabledCloudWatchLogsExports__c": "alert\naudit\nlistener\noemagent\ntrace",
          "CA10__clusterArn__c": "",
          "CA10__status__c": "available",
          "Id": "002"
        },
        {
          "expectedResult": {
            "status": "INCOMPLIANT",
            "conditionIndex": "400",
            "conditionText": "otherwise",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-12-17T04:44:14Z" },
          "CA10__disappearanceTime__c": null,
          "CA10__enabledCloudWatchLogsExports__c": "",
          "CA10__clusterArn__c": "",
          "CA10__status__c": "available",
          "Id": "003"
        }
      ]
  - path: /types/CA10__CaAwsDbInstance__c/object.extracts.yaml
    md5Hash: E3FA5A211AA9AD2418645BB09047D3D3
    content: "---\nextracts:\n# Not Nullable. Can't have no access, retrieved via\
      \ rds:DescribeDBInstances\n  - name: CA10__engine__c\n    value:\n      FIELD:\n\
      \        path: CA10__engine__c\n        undeterminedIf:\n          isEmpty:\
      \ \"Corrupted data. DB Instance Engine cannot be empty.\"\n# Not Nullable. Can't\
      \ have no access, retrieved via rds:DescribeDBInstances\n  - name: CA10__endpointPort__c\n\
      \    value:\n      FIELD:\n        path: CA10__endpointPort__c\n        undeterminedIf:\n\
      \          isEmpty: \"Corrupted data. DB Endpoint Port cannot be empty.\"\n\
      # Checkbox. Can't have no access, retrieved via rds:DescribeDBInstances\n  -\
      \ name: CA10__publiclyAccessible__c\n    value:\n      FIELD:\n        path:\
      \ CA10__publiclyAccessible__c\n# Checkbox. Can't have no access, retrieved via\
      \ rds:DescribeDBInstances\n  - name: CA10__storageEncrypted__c\n    value: \n\
      \      FIELD:\n        path: CA10__storageEncrypted__c\n# Checkbox. Can't have\
      \ no access, retrieved via rds:DescribeDBInstances\n  - name: CA10__autoMinorVersionUpgrade__c\n\
      \    value: \n      FIELD:\n        path: CA10__autoMinorVersionUpgrade__c\n\
      # Checkbox. Can't have no access, retrieved via rds:DescribeDBInstances\n  -\
      \ name: CA10__multiAz__c\n    value: \n      FIELD:\n        path: CA10__multiAz__c\n\
      # Nullable. Values: available, backing-up, creating ...\n  - name: \"CA10__status__c\"\
      \n    value:\n      FIELD:\n        path: \"CA10__status__c\"\n# Nullable.\n\
      \  - name: \"CA10__createTime__c\"\n    value:\n      FIELD:\n        path:\
      \ \"CA10__createTime__c\"\n# Nullable.\n  - name: \"CA10__averageCpuOneMonth__c\"\
      \n    value:\n      FIELD:\n        path: \"CA10__averageCpuOneMonth__c\"\n\
      # Nullable.\n  - name: \"CA10__regionName__c\"\n    value:\n      FIELD:\n \
      \       path: \"CA10__regionName__c\"\n# Nullable.\n  - name: \"CA10__diskReadIopsAvg30d__c\"\
      \n    value:\n      FIELD:\n        path: \"CA10__diskReadIopsAvg30d__c\"\n\
      # Nullable.\n  - name: \"CA10__diskWriteIopsAvg30d__c\"\n    value:\n      FIELD:\n\
      \        path: \"CA10__diskWriteIopsAvg30d__c\"\n# Nullable.\n  - name: \"CA10__databaseConnectionsAvg30d__c\"\
      \n    value:\n      FIELD:\n        path: \"CA10__databaseConnectionsAvg30d__c\"\
      \n# Not nullable. Can't have no access, retrieved via rds:DescribeDBInstances\n\
      \  - name: \"CA10__backupRetentionPeriod__c\"\n    value:\n      FIELD:\n  \
      \      path: \"CA10__backupRetentionPeriod__c\"\n# Text.\n  - name: CA10__masterUsername__c\n\
      \    value:\n      FIELD:\n        path: CA10__masterUsername__c\n# Checkbox.\n\
      \  - name: CA10__iamDatabaseAuthenticationEnabled__c\n    value:\n      FIELD:\n\
      \        path: CA10__iamDatabaseAuthenticationEnabled__c\n# Text.\n  - name:\
      \ CA10__enabledCloudWatchLogsExports__c\n    value:\n      FIELD:\n        path:\
      \ CA10__enabledCloudWatchLogsExports__c\n# Checkbox.\n  - name: CA10__deletionProtection__c\n\
      \    value:\n      FIELD:\n        path: CA10__deletionProtection__c\n# Nullable.\
      \ Can't have no access, retrieved via rds:DescribeDBInstances\n  - name: CA10__clusterArn__c\n\
      \    value:\n      FIELD:\n        path: CA10__clusterArn__c\n# Not nullable.\
      \ Can't have no access, retrieved via rds:DescribeDBInstances\n  - name: \"\
      CA10__monitoringInterval__c\"\n    value:\n      FIELD:\n        path: \"CA10__monitoringInterval__c\"\
      \n# Checkbox.\n  - name: CA10__copyTagsToSnapshot__c\n    value:\n      FIELD:\n\
      \        path: CA10__copyTagsToSnapshot__c\n"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "001",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "002",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "399",
      "conditionText" : "extract('CA10__enabledCloudWatchLogsExports__c').isNotEmpty()",
      "runtimeError" : null
    }
  }, {
    "Id" : "003",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "400",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAwsDbInstance__c()
  RETURNS ARRAY<STRUCT<
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__status__c STRING,
      CA10__clusterArn__c STRING,
      CA10__enabledCloudWatchLogsExports__c STRING,
      Id STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-12-17T04:44:14Z")
    },
    "CA10__disappearanceTime__c" : new Date("2025-12-12T10:23:44Z"),
    "CA10__status__c" : "available",
    "CA10__clusterArn__c" : "",
    "CA10__enabledCloudWatchLogsExports__c" : "",
    "Id" : "001"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-12-17T04:44:14Z")
    },
    "CA10__status__c" : "available",
    "CA10__clusterArn__c" : "",
    "CA10__enabledCloudWatchLogsExports__c" : "alert\naudit\nlistener\noemagent\ntrace",
    "Id" : "002"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-12-17T04:44:14Z")
    },
    "CA10__status__c" : "available",
    "CA10__clusterArn__c" : "",
    "CA10__enabledCloudWatchLogsExports__c" : "",
    "Id" : "003"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAwsDbInstance__c(
      obj STRUCT<
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__status__c STRING,
          CA10__clusterArn__c STRING,
          CA10__enabledCloudWatchLogsExports__c STRING,
          Id STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
  var TextLib = new function () {
      this.normalize = function(arg) {
          return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
      };
      this.isEmpty = function(arg) {
          return this.normalize(arg) == '';
      };
      this.isNotEmpty = function(arg) {
          return this.normalize(arg) != '';
      };
      this.equal = function(left, right) {
          return this.normalize(left) == this.normalize(right);
      };
      this.notEqual = function(left, right) {
          return this.normalize(left) != this.normalize(right);
      };
      this.startsWith = function(arg, substring) {
          return this.normalize(arg).startsWith(this.normalize(substring));
      };
      this.endsWith = function(arg, substring) {
          return this.normalize(arg).endsWith(this.normalize(substring));
      };
      this.contains = function(arg, substring) {
          return this.normalize(arg).includes(this.normalize(substring));
      };
      this.containsAll = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
      };
      this.containsAny = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
      };
  }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function extract3() { if (!this.out) { this.out = obj.CA10__status__c; } return this.out; };
      references1.push('Status [obj.CA10__status__c]: ' + obj.CA10__status__c);
      if (TextLib.notEqual(extract3.call(extract3), 'available')) {
          return {status: 'INAPPLICABLE', conditionIndex: 199, conditionText: "extract('CA10__status__c') != 'available'", currentStateMessage: "The Instance is not available.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[2], conditionIndex:[200..299]
      function extract6() { if (!this.out) { this.out = obj.CA10__clusterArn__c; } return this.out; };
      references1.push('Cluster ARN [obj.CA10__clusterArn__c]: ' + obj.CA10__clusterArn__c);
      if (TextLib.isNotEmpty(extract6.call(extract6))) {
          return {status: 'INAPPLICABLE', conditionIndex: 299, conditionText: "extract('CA10__clusterArn__c').isNotEmpty()", currentStateMessage: "This policy doesn't apply to Cluster Instances.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[3], conditionIndex:[300..399]
      function extract9() { if (!this.out) { this.out = obj.CA10__enabledCloudWatchLogsExports__c; } return this.out; };
      references1.push('Enabled CloudWatch Logs Exports [obj.CA10__enabledCloudWatchLogsExports__c]: ' + obj.CA10__enabledCloudWatchLogsExports__c);
      if (TextLib.isNotEmpty(extract9.call(extract9))) {
          return {status: 'COMPLIANT', conditionIndex: 399, conditionText: "extract('CA10__enabledCloudWatchLogsExports__c').isNotEmpty()", currentStateMessage: "The RDS Instance is configured to publish logs to CloudWatch.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      return {status: 'INCOMPLIANT', conditionIndex: 400, conditionText: "otherwise", currentStateMessage: "The RDS Instance is not configured to publish logs to CloudWatch.", currentStateReferences: references1.join('\n'), remediation: "Modify the RDS instance to enable CloudWatch logs.", runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__status__c AS CA10__status__c,
          sObject.CA10__clusterArn__c AS CA10__clusterArn__c,
          sObject.CA10__enabledCloudWatchLogsExports__c AS CA10__enabledCloudWatchLogsExports__c,
          sObject.Id AS Id,
          process_CA10__CaAwsDbInstance__c(
              STRUCT(
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__status__c AS CA10__status__c,
                  sObject.CA10__clusterArn__c AS CA10__clusterArn__c,
                  sObject.CA10__enabledCloudWatchLogsExports__c AS CA10__enabledCloudWatchLogsExports__c,
                  sObject.Id AS Id
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAwsDbInstance__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
